
function [W,Q,W0,objvals,specificTrain,specificTest,shareTrain,shareTest]=...
    mtlProjectVOrthogonalityHingLossExtThreeSteps(XTrain,XTest,YTrain...
    ,M,alpha,gamma,lambda,maxIterOut,maxIterIn)

addpath('./FOptM-share');  BETA=alpha*(ones(10,1));
setNo=length(XTrain); optspca.ReducedDim=M; traceList=[];

for ii=1:setNo
    X_i=XTrain{ii};    Y_i=YTrain{ii};    
    traceList(ii)=sum(sum(X_i.^2));
    d(ii)=size(X_i,1);       % dimension of orginal feature
    n(ii)=size(X_i,2);       % sample number
    C=size(Y_i,1);
    Q{ii}=PCA(X_i',optspca);
    M=size(Q{ii},2);
    W{ii}=rand(M,C);   
end

W0=rand(M,size(YTrain{1},1));
errorFun=@max;  iterOut=1;  optPar=1;
objvals=objHere(Q,XTrain,W,YTrain,alpha,W0,BETA,gamma,lambda,traceList);
iterSubIte=1;
while and(optPar>1e-1,iterOut<maxIterOut) 
    objvalsSub=objHere(Q,XTrain,W,YTrain,alpha,W0,BETA,gamma,lambda,traceList);    

    % Optimizing W0    
    W0=optimizingW0(XTrain,W,Q,YTrain,alpha,lambda);
    obj_old=objHere(Q,XTrain,W,YTrain,alpha,W0,BETA,gamma,lambda,traceList);
    objvalsSub=[objvalsSub,obj_old];

    % Optimizing W 
    for ii=1:setNo
        X_i=XTrain{ii};   W_i=W{ii};      Q_i=Q{ii};
        Y_i=YTrain{ii}-lambda*W0'*Q_i'*XTrain{ii};
        beta_i=BETA(ii);
        W_i_new=optimizingWi(X_i,Q_i,Y_i,beta_i,lambda);          % solve W_i
        W{ii}=W_i_new; clearvars W_i_new
    end
    obj_old=objHere(Q,XTrain,W,YTrain,alpha,W0,BETA,gamma,lambda,traceList);
    objvalsSub=[objvalsSub,obj_old];
    optParSubIte=max(objvalsSub(end-1)-objvalsSub(end),objvalsSub(end-2)-objvalsSub(end-1));
    fprintf(['iterOut: ' num2str(iterSubIte) '   Objective: ',num2str(obj_old),...
        '   Decrease: ' num2str(optParSubIte) '\n'])
    iterSubIte=iterSubIte+1;
    objvals=[objvals,objvalsSub(end-1:end)];

    % optimizing Q_i
    for ii=1:setNo
        X_i=XTrain{ii};    W_i=W{ii};    Q_i=Q{ii};
        Y_i=YTrain{ii};    trX=traceList(ii);
        [Q_i_new,out,objs]=optimizingQi(Q_i,X_i,W_i,Y_i,BETA(ii),W0,gamma,lambda,trX,maxIterIn);
        Q{ii}=Q_i_new;  clearvars Q_i_new
    end

    obj_old=objHere(Q,XTrain,W,YTrain,alpha,W0,BETA,gamma,lambda,traceList);
    objvals=[objvals,obj_old];
    optPar=errorFun([objvals(end-2:end-1)-objvals(end-1:end)]);

    [shareCTrain,specificCTrain]=shareSpecificCompute(W0,Q,W,XTrain,lambda);
    [shareCTest,specificCTest]=shareSpecificCompute(W0,Q,W,XTest,lambda);
    specificTrain{iterOut}=specificCTrain;    specificTest{iterOut}=specificCTest;
    shareTrain{iterOut}=shareCTrain;          shareTest{iterOut}=shareCTest;
    iterOut=iterOut+1;
end

function ff=objHere(Q,X,W,Y,alph,W0,BETA,gamar,lambda,traceList)
ff=0;
for ii=1:length(X)
    X_i=X{ii};    W_i=W{ii};    Q_i=Q{ii};
    Y_i=Y{ii};    AA=Q_i'*X_i;
    matTmp1=(lambda*W0+(1-lambda)*W_i)'*(AA)-Y_i;
    ff=ff+sum(sum(matTmp1.^2))+BETA(ii)*sum(sum(W_i.^2))...
        -gamar*sum(sum(AA.^2))+gamar*traceList(ii);
end
ff=ff+alph*sum(sum(W0.^2));

function [ff, ffQi]=objHereInner(Q_i,X_i,W_i,Y_i,betai,W0,gamar,lambda,trX)
AA=Q_i'*X_i;
Wbar=(1-lambda)*W_i+lambda*W0;
matTmp1=Wbar'*AA-Y_i;
ff=sum(sum(matTmp1.^2))-gamar*sum(sum(AA.^2))...
    +gamar*trX;
ffQi=X_i*(matTmp1'*Wbar')-gamar*X_i*AA';
ffQi=2*ffQi;

function [Q_i_new,out,objs]=optimizingQi(Q_i,X_i,W_i,Y_i,betai,W0,gamar,lambda,trX,maxIterIn)
opts.record = 0;
opts.mxitr  =maxIterIn;
opts.xtol = 1e-3;
opts.gtol = 1e-3;
opts.ftol = 1e-4;
out.tau = 1e-3;
%trX=trace(X_i'*X_i);
[Q_i_new, out,objs]= OptStiefelGBB(Q_i, @objHereInner, opts, X_i,W_i,Y_i,betai,W0,gamar,lambda,trX); 


function W_i_new=optimizingWi(X_i,Q_i,Y_i,alph,lambda)
multP=(1-lambda)^2;
AA=Q_i'*X_i;
W_i_new=Y_i*(AA')*pinv(multP*(AA*AA')+alph*eye(size(Q_i,2)));
W_i_new=(1-lambda)*W_i_new';

function W_0_new=optimizingW0(X,W,Q,Y,alph,lambda)
matToInv=alph*eye(size(W{1},1));
matBy=zeros(size(W{1}));
multP1=lambda^2;
multP2=(1-lambda);
for ii=1:length(X)
    Qii=Q{ii};Xii=X{ii};
    QiiTXii=Qii'*Xii;
    matToInv=matToInv+multP1*(QiiTXii*QiiTXii');
    matBy=matBy+QiiTXii*(Y{ii}'-multP2*QiiTXii'*W{ii});
end
W_0_new=(matToInv\matBy)*lambda;